//
//  Helper.swift
//  MVisaSDKPrototypeSwift
//
//

import Foundation
import  UIKit
import  MVisaSDK

class Helper {
    static let visaColor = UIColor(red:0.08, green:0.10, blue:0.32, alpha:1.0)
    static let cellTitles = [["Pay Merchant", "Pay a Friend", "Withdraw Cash", "Pay Merchant Alias", "Pay a Friend Alias"], ["Request Payment", "Refund"]]
    static let sectionTitles = ["Consumer Flow", "Merchant Flow"]
    
    static func getPayFriendResponseStr(successful: Bool, response: MVisaPayFriendResponse?, error: MVisaError?) -> String {
        var responseStr = "SUCCESSFUL: " + String(successful) + "\n"
        if successful {
            responseStr = responseStr + "RESPONSE:\n"
            responseStr = responseStr + "newUser: " + getStr(field: response?.newUser as AnyObject?) + "\n"
            responseStr = responseStr + "payeeCardNumber: " + getStr(field: response?.payeeCardNumber as AnyObject?) + "\n"
            responseStr = responseStr + "payeeIndex: " + getStr(field: response?.payeeIndex as AnyObject?) + "\n"
            responseStr = responseStr + "payeeName: " + getStr(field: response?.payeeName as AnyObject?) + "\n"
            responseStr = responseStr + "senderCardIndex: " + getStr(field: response?.senderCardIndex as AnyObject?) + "\n"
            responseStr = responseStr + "shouldAddNewUserToPayeeList: " + getStr(field: response?.shouldAddNewUserToPayeeList as AnyObject?) + "\n"
            responseStr = responseStr + "transactionAmount: " + getStr(field: response?.transactionAmount as AnyObject?) + "\n"
        } else {
            responseStr = "ERROR:\n"
            for e in error!.errorCodes {
                responseStr = String(e) + "\n"
            }
        }
        return responseStr
        
    }
    
    static func getPayMerchantResponseStr(successful: Bool, response: MVisaPayMerchantResponse?, error: MVisaError?) -> String {
        var responseStr = "SUCCESSFUL: " + String(successful) + "\n"
        if successful {
            responseStr = responseStr + "RESPONSE:\n"
            responseStr = responseStr + "merchantName: " + getStr(field: response?.merchantName as AnyObject?) + "\n"
            responseStr = responseStr + "billAmount: " + getStr(field: response?.transactionAmount as AnyObject?) + "\n"
            responseStr = responseStr + "additionalAmount: " + getStr(field: response?.additionalAmount as AnyObject?) + "\n"
            responseStr = responseStr + "primaryID: " + getStr(field: response?.primaryID as AnyObject?) + "\n"
            responseStr = responseStr + "secondaryID: " + getStr(field: response?.secondaryID as AnyObject?) + "\n"
            responseStr = responseStr + "cardIndex: " + getStr(field: response?.selectedCardIndex as AnyObject?) + "\n"
            responseStr = responseStr + "currencyCode: " + getStr(field: response?.currencyCode as AnyObject?) + "\n"
            responseStr = responseStr + "country: " + getStr(field: response?.countryCode as AnyObject?) + "\n"
            responseStr = responseStr + "city: " + getStr(field: response?.cityName as AnyObject?) + "\n"
            responseStr = responseStr + "merchantCategoryCode: " + getStr(field: response?.merchantCategoryCode as AnyObject?) + "\n"
            responseStr = responseStr + "payloadFormatIndicator: " + getStr(field: response?.payloadFormatIndicator as AnyObject?) + "\n"
            responseStr = responseStr + "pointOfInitiation: " + getStr(field: response?.pointOfInitiation as AnyObject?) + "\n"
            responseStr = responseStr + "postalCode: " + getStr(field: response?.postalCode as AnyObject?) + "\n"
            responseStr = responseStr + "masterCardPAN1: " + getStr(field: response?.masterCardPAN1 as AnyObject?) + "\n"
            responseStr = responseStr + "masterCardPAN2: " + getStr(field: response?.masterCardPAN2 as AnyObject?) + "\n"
            responseStr = responseStr + "npciid1: " + getStr(field: response?.npciid1 as AnyObject?) + "\n"
            responseStr = responseStr + "npciid2: " + getStr(field: response?.npciid2 as AnyObject?) + "\n"
            responseStr = responseStr + "crc: " + getStr(field: response?.crc as AnyObject?) + "\n"
            responseStr = responseStr + "tag03: " + getStr(field: response?.aliasID as AnyObject?) + "\n"
            responseStr = responseStr + "tag08: " + getStr(field: response?.tag08 as AnyObject?) + "\n"
            responseStr = responseStr + "additionalDataField: " + getStr(field: response?.additionalDataField as AnyObject?) + "\n"
            responseStr = responseStr + "billID: " + getStr(field: response?.billID as AnyObject?) + "\n"
            responseStr = responseStr + "mobileNumber: " + getStr(field: response?.mobileNumber as AnyObject?) + "\n"
            responseStr = responseStr + "storeID: " + getStr(field: response?.storeID as AnyObject?) + "\n"
            responseStr = responseStr + "loyaltyNumber: " + getStr(field: response?.loyaltyNumber as AnyObject?) + "\n"
            responseStr = responseStr + "referenceID: " + getStr(field: response?.referenceID as AnyObject?) + "\n"
            responseStr = responseStr + "consumerID: " + getStr(field: response?.consumerID as AnyObject?) + "\n"
            responseStr = responseStr + "terminalID: " + getStr(field: response?.terminalID as AnyObject?) + "\n"
            responseStr = responseStr + "purpose: " + getStr(field: response?.purpose as AnyObject?) + "\n"
            responseStr = responseStr + "additionalConsumerDataRequest: " + getStr(field: response?.additionalConsumerDataRequest as AnyObject?) + "\n"
            responseStr = responseStr + "addDataMasterCard1: " + getStr(field: response?.addDataMasterCard1 as AnyObject?) + "\n"
            responseStr = responseStr + "addDataMasterCard2: " + getStr(field: response?.addDataMasterCard2 as AnyObject?) + "\n"
            responseStr = responseStr + "addDataNpci1: " + getStr(field: response?.addDataNpci1 as AnyObject?) + "\n"
            responseStr = responseStr + "addDataNpci1: " + getStr(field: response?.addDataNpci1 as AnyObject?) + "\n"
            responseStr = responseStr + "tagSixtyTwo10: " + getStr(field: response?.tagSixtyTwo10 as AnyObject?) + "\n"
            
        } else {
            responseStr = "ERROR:\n"
            for e in error!.errorCodes {
                responseStr = String(e) + "\n"
            }
        }
        return responseStr
    }
    
    static func getWithdrawCashResponseStr(successful: Bool, response: MVisaWithdrawCashResponse?, error: MVisaError?) -> String {
        var responseStr = "SUCCESSFUL: " + String(successful) + "\n"
        if successful {
            responseStr = responseStr + "RESPONSE:\n"
            responseStr = responseStr + "agentID: " + getStr(field: response?.agentID as AnyObject?) + "\n"
            responseStr = responseStr + "agentName: " + getStr(field: response?.agentName as AnyObject?) + "\n"
            responseStr = responseStr + "transactionAmount: " + getStr(field: response?.transactionAmount as AnyObject?) + "\n"
            responseStr = responseStr + "selectedCardIndex: " + getStr(field: response?.selectedCardIndex as AnyObject?) + "\n"
            responseStr = responseStr + "currencyCode: " + getStr(field: response?.currencyCode as AnyObject?) + "\n"
            responseStr = responseStr + "merchantCategoryCode: " + getStr(field: response?.mcc as AnyObject?) + "\n"
            responseStr = responseStr + "city: " + getStr(field: response?.city as AnyObject?) + "\n"
            responseStr = responseStr + "country: " + getStr(field: response?.country as AnyObject?) + "\n"
        } else {
            responseStr = "ERROR:\n"
            for e in error!.errorCodes {
                responseStr = String(e) + "\n"
            }
        }
        return responseStr
    }
    
    static func getStr(field: AnyObject?) -> String {
        if let value = field {
            return String(describing: value)
        } else {
            return "nil"
        }
    }

}

extension ViewController: UITableViewDataSource, UITableViewDelegate {
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        
        tableView.deselectRow(at: indexPath, animated: true)
        
        switch indexPath.section {
        case 0:
            switch indexPath.row {
            case 0:
                initiateMVisaSDKPayMerchantFlow()
            case 1:
                initiateMVisaSDKPayFriendFlow()
            case 2:
                initiateMVisaSDKWithdrawCashFlow()
            case 3:
                initiateMVisaSDKPayMerchantAliasFlow()
            case 4:
                initiatePayFriendAliasFlow()
            default:
                print("To be implemented")
            }
        case 1:
            switch indexPath.row {
            case 0:
                initiateMVisaMerchantSDKRequestPaymentFlow()
            case 1:
                initiateMVisaMerchantSDKRefundFlow()
            default:
                print("To be implemented")
            }
        default:
            switch indexPath.row {
            case 0:
                print("To be implemented")
            default:
                print("To be implemented")
            }
        }
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return Helper.cellTitles.count
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return Helper.cellTitles[section].count
    }
    
    func tableView(_ tableView: UITableView, titleForHeaderInSection section: Int) -> String? {
        return Helper.sectionTitles[section]
    }
    
    func tableView(_ tableView: UITableView, heightForHeaderInSection section: Int) -> CGFloat {
        return 28
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 70
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "cell", for: indexPath)
        cell.textLabel?.text = Helper.cellTitles[indexPath.section][indexPath.row]
        cell.textLabel?.textColor = UIColor.white
        cell.textLabel?.backgroundColor = Helper.visaColor
        return cell
    }
    
}


